<?php

namespace Drupal\muser_project\Plugin\Action;

use Drupal\Core\Cache\Cache;
use Drupal\Core\Field\FieldUpdateActionBase;
use Drupal\Core\Session\AccountInterface;

/**
 * Base class for flagging status update actions.
 */
abstract class ApplicationStatusUpdateBase extends FieldUpdateActionBase {

  /**
   * {@inheritdoc}
   */
  public function access($object, AccountInterface $account = NULL, $return_as_object = FALSE) {
    $this->account = $account;
    $access_service = \Drupal::service('muser_project.flagging_access_check');
    return $access_service->access($account, $object);
  }

  /**
   * {@inheritdoc}
   */
  public function executeMultiple(array $objects) {
    parent::executeMultiple($objects);
    // Clear the review info block's build array cache.
    Cache::invalidateTags(['application_review_count:' . $this->account->id()]);
  }

}
